<!DOCTYPE html>
<!--[if lt IE 7 ]><html class="ie ie6" lang="en"> <![endif]-->
<!--[if IE 7 ]><html class="ie ie7" lang="en"> <![endif]-->
<!--[if IE 8 ]><html class="ie ie8" lang="en"> <![endif]-->
<!--[if (gte IE 9)|!(IE)]><!-->
<html lang="en">
<!--<![endif]-->

<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">
    <meta name="keywords" content="">

    <title>Pizzashop | Documentation by Michael Sieber</title>

    <link rel="shortcut icon" href="images/favicon.ico" type="image/x-icon">

    <link rel="stylesheet" type="text/css" href="fonts/font-awesome-4.3.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" href="css/stroke.css">
    <link rel="stylesheet" type="text/css" href="css/bootstrap.css">
    <link rel="stylesheet" type="text/css" href="css/animate.css">
    <link rel="stylesheet" type="text/css" href="css/prettyPhoto.css">
    <link rel="stylesheet" type="text/css" href="css/style.css">

    <link rel="stylesheet" type="text/css" href="js/syntax-highlighter/styles/shCore.css" media="all">
    <link rel="stylesheet" type="text/css" href="js/syntax-highlighter/styles/shThemeRDark.css" media="all">

    <!-- CUSTOM -->
    <link rel="stylesheet" type="text/css" href="css/custom.css">

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->

</head>

<body>

    <div id="wrapper">

        <div class="container">

            <section id="top" class="section docs-heading">

                <div class="row">
                    <div class="col-md-12">
                        <div class="big-title text-center">
                            <img src="images/fhv.png" width="25%" />
                            <h1>Pizzashop Documentation</h1>
                            <p class="lead"></p>
                        </div>
                        <!-- end title -->
                    </div>
                    <!-- end 12 -->
                </div>
                <!-- end row -->

                <hr>

            </section>
            <!-- end section -->

            <div class="row">

                <div class="col-md-3">
                    <nav class="docs-sidebar" data-spy="affix" data-offset-top="300" data-offset-bottom="200"
                        role="navigation">
                        <ul class="nav">
                            <li><a href="#line1">Getting Started</a></li>
                            <li><a href="#line2">How to setup a project</a></li>
                            <ul class="nav">
                                </li>
                                <li><a href="#line2_1">Quickstart</a></li>
                                <li><a href="#line2_2">Generator questions</a></li>
                            </ul>
                            <li><a href="#line3">Sentiment Analysis</a></li>
                            <ul class="nav">
                                <li><a href="#line3_1">Project description</a></li>
                                <li><a href="#line3_2">Used technologies and cloud services</a></li>
                                <li><a href="#line3_3">CI/CD Pipeline</a></li>
                                <li><a href="#line3_4">UML diagrams</a></li>
                                <!--<li><a href="#line3_5">JavaDoc</a></li>-->
                                <li><a href="#line3_6">Unit test report</a></li>
                                <li><a href="#line3_7">Integration test report</a></li>
                                <!--<li><a href="#line3_8">Automated UAT report</a></li>-->
                                <!--<li><a href="#line3_9">Performance test report</a></li>-->
                                <li><a href="#line3_10">SonarQube Report</a></li>
                            </ul>
                            </li>
                        </ul>
                    </nav>
                </div>
                <div class="col-md-9">

                    <section class="welcome">

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 class="dark-text">Introduction
                                    <hr>
                                </h2>
                                <div class="row">

                                    <div class="col-md-12 full">
                                        <div>
                                            <p>This documentation is part of the pizzashop example project for
                                                the course "Software quality and lifecycle" at the University of Applied
                                                Sciences Vorarlberg
                                            </p>

                                            <p>This documentation is to help you to setup a JHipster project with a
                                                continuous delivery pipeline.</p>

                                        </div>
                                    </div>

                                </div>
                                <!-- end row -->
                            </div>
                        </div>
                    </section>

                    <section id="line1" class="section">

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 class="dark-text">Getting Started <a href="#top">#back to top</a>
                                    <hr>
                                </h2>
                            </div>
                            <!-- end col -->
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12">
                                <p>Before we start with creating an application you have to setup the workstation with
                                    the required tools.</p>

                                <h4>Local installation with NPM</h4>

                                1. Install Java 11<br />
                                2. Install Node.js from the Node.js website (please use an LTS 64-bit version, non-LTS
                                versions are not supported)<br />
                                3. Install JHipster: npm install -g generator-jhipster<br />
                                4. (optional) If you want to use a module or a blueprint (for instance from the JHipster
                                Marketplace), install Yeoman: npm install -g yo<br />

                                <a href="https://www.jhipster.tech/installation/">Official documentation</a>
                            </div>
                            <!-- end col -->
                        </div>
                        <!-- end row -->

                    </section>
                    <!-- end section -->

                    <section id="line2" class="section">

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 class="dark-text">Create an application<a href="#top">#back to top</a>
                                    <hr>
                                </h2>
                            </div>
                            <!-- end col -->
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 id="line2_1">Quickstart <a href="#top" class="toplink">#back to top</a>
                                    <hr>
                                </h2>

                                First of all, create an empty directory in which you will create your application:<br />
                                <code>mkdir myapplication</code><br />
                                Go to that directory:<br />
                                <code>cd myapplication/</code><br />
                                To generate your application, type:<br />
                                <code>jhipster</code><br />
                                Answer the questions asked by the generator to create an application tailored to your
                                needs. Those options are described in the next section.<br />
                                Once the application is generated, you can launch it using Maven (<code>./mvnw</code> on
                                Linux/MacOS/Windows PowerShell, <code>mvnw</code> on Windows Cmd) or Gradle
                                (<code>./gradlew</code> on
                                Linux/MacOS/Windows PowerShell, <code>gradlew</code> on Windows Cmd).<br />
                                <strong>Note</strong> if you are using Maven and changed front end files after first run
                                of the <code>./mvnw</code>
                                command then you must run <code>./mvnw -Pwebpack</code> to see the latest front end
                                version (Gradle
                                detects front end changes automatically and recompiles front end if needed).
                                The application will be available on http://localhost:8080<br />
                                <strong>Important</strong> if you want to have “live reload” of your
                                JavaScript/TypeScript code, you will
                                need run <code>npm start</code> or <code>yarn start</code>. You can go to the Using
                                JHipster in development page
                                for more information.<br />
                                If you are using “live reload” then you can speed up server start up by excluding client
                                side tasks by <code>./mvnw -P-webpack</code> or <code>./gradlew -x webpack</code>. It
                                speeds up especially Gradle.
                            </div>
                            <!-- end col -->
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 id="line2_2">Generator questions<a href="#top" class="toplink">#back to top</a>
                                    <hr>
                                </h2>
                                See <a href="https://www.jhipster.tech/creating-an-app/#2">official documentation</a>
                            </div>
                            <!-- end col -->
                        </div>
                        <!-- end row -->

                    </section>
                    <!-- end section -->

                    <section id="line3" class="section">

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 class="dark-text">Pizzashop<a href="#top">#back to top</a>
                                    <hr>
                                </h2>
                            </div>
                            <!-- end col -->
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 id="line3_1">Project description <a href="#top" class="toplink">#back to top</a>
                                </h2>
                                This project demonstrates the usage of code generation from UML diagrams using JHipster
                                and publishing the content with a continuous integration and continuous delivery
                                pipeline to ensure the quality of the product.
                                <br />
                                Try the application: <a
                                    href="http://pizzashop-pizza-shop.apps.ca-central-1.starter.openshift-online.com/"
                                    target="_blank">Pizzashop</a><br />

                                Project link: <a href="https://gitlab.com/fhv-ms/pizza-shop/pizzashop">GitLab</a><br />
                                <img src="https://gitlab.com/fhv-ms/pizza-shop/pizzashop/badges/master/pipeline.svg" />
                            </div>
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 id="line3_2">Used technologies and cloud services <a href="#top"
                                        class="toplink">#back to top</a></h2>
                                The following technologies and cloud service are used for this project (all of them
                                provide a free tier for developers):
                                <ul style="list-style: square; padding-left: 30px">
                                    <li><a href="https://www.jhipster.tech" target="_blank">JHipster</a>
                                        <ul>
                                            <li>Bootstrap the application and generate entities from UML diagrams</li>
                                        </ul>
                                    </li>
                                    <li><a href="https://gitlab.com/" target="_blank">GitLab</a>
                                        <ul>
                                            <li>Source control management</li>
                                        </ul>
                                    </li>
                                    <li><a href="https://www.openshift.com/" target="_blank">OpenShift</a>
                                        <ul>
                                            <li>Deployment and staging of the application</li>
                                        </ul>
                                    </li>
                                    <li><a href="https://sonarcloud.io" target="_blank">SonarCloud</a>
                                        <ul>
                                            <li>Static code analysis with SonarQube</li>
                                        </ul>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 id="line3_3">CI/CD Pipeline <a href="#top" class="toplink">#back to top</a></h2>
                                The pipeline got implemented in GitLab CI:<br />
                                <img src="images/pipeline1.png" style="margin-top: 0px;" /><br />
                                <img src="images/pipeline2.png" style="margin-top: 0px;" /><br />
                            </div>
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 id="line3_4">UML diagrams <a href="#top" class="toplink">#back to top</a></h2>
                                The class diagram used for generating the application:<br />
                                <img src="https://gitlab.com/fhv-ms/pizza-shop/pizzashop/raw/master/pizzashop.png"
                                    style="margin-top: 0px;" />
                            </div>
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 id="line3_6">Unit test report <a href="#top" class="toplink">#back to top</a></h2>
                                The following report is generated with the Maven Jacoco Plugin:
                                <iframe src="generated/test/index.html"
                                    style="width: 100%; height: 500px;"></iframe><br />
                                The following report is generated by Jest:
                                <iframe src="generated/lcov-report/index.html"
                                    style="width: 100%; height: 500px;"></iframe>
                            </div>
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 id="line3_7">Integration test report <a href="#top" class="toplink">#back to top</a>
                                </h2>
                                The following report is generated with the Maven Jacoco Plugin:
                                <iframe src="generated/integrationTest/index.html"
                                    style="width: 100%; height: 500px;"></iframe>
                            </div>
                        </div>
                        <!-- end row -->

                        <div class="row">
                            <div class="col-md-12 left-align">
                                <h2 id="line3_10">Static code analysis report <a href="#top" class="toplink">#back to
                                        top</a></h2>
                                The detailed report can be found <a href="https://sonarcloud.io/dashboard?id=pizzashop"
                                    target="_blank">here</a><br />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=alert_status" />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=bugs" /><br />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=code_smells" />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=coverage" /><br />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=duplicated_lines_density" />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=ncloc" /><br />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=sqale_rating" />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=reliability_rating" /><br />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=security_rating" />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=sqale_index" />
                                <img
                                    src="https://sonarcloud.io/api/project_badges/measure?project=pizzashop&metric=vulnerabilities" />
                            </div>
                        </div>
                        <!-- end row -->
                    </section>
                    <!-- end section -->

                </div>
                <!-- // end .col -->

            </div>
            <!-- // end .row -->

        </div>
        <!-- // end container -->

    </div>
    <!-- end wrapper -->

    <script src="js/jquery.min.js"></script>
    <script src="js/bootstrap.min.js"></script>
    <script src="js/retina.js"></script>
    <script src="js/jquery.fitvids.js"></script>
    <script src="js/wow.js"></script>
    <script src="js/jquery.prettyPhoto.js"></script>

    <!-- CUSTOM PLUGINS -->
    <script src="js/custom.js"></script>
    <script src="js/main.js"></script>

    <script src="js/syntax-highlighter/scripts/shCore.js"></script>
    <script src="js/syntax-highlighter/scripts/shBrushXml.js"></script>
    <script src="js/syntax-highlighter/scripts/shBrushCss.js"></script>
    <script src="js/syntax-highlighter/scripts/shBrushJScript.js"></script>

</body>

</html>